; Created by "The BorderTron 3000"
; By Chris Cowley. <chrrris@gmail.com>
; Please use this code freely.

                  org   40000
Start:            call  SetupIntHandler
                  call  50000		; Initialise ST music routine

                  ; Setup registers for our chosen border colours
                  ; C is used by the display loop so is out of bounds
                  ld    a,0
                  ld    hl,$0207
                  ld    de,$0206

BorderLoop:
                  halt           ; wait for start of frame
                  out   (c),a    ; background colour
                  ld    bc,$0002
WaitLoop1:        nop
                  djnz  WaitLoop1
                  out   (c),a
                  out   (c),a
                  nop
                  dec   c
                  jr    nz,WaitLoop1

                  ld    bc,$04FE

                  ; Row 0
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background

                  ; Row 1
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background

                  ; Row 2
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  nop
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background
                  nop
                  nop

                  ; Row 3
                  out   (c),a
                  out   (c),d
                  out   (c),d
                  nop
                  out   (c),a
                  out   (c),a
                  out   (c),d
                  out   (c),d
                  nop
                  out   (c),a
                  nop
                  nop
                  out   (c),d
                  nop
                  out   (c),a
                  nop
                  out   (c),d
                  out   (c),a
                  out   (c),d
                  out   (c),a
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background

                  ; Row 4
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background

                  ; Row 5
                  out   (c),a
                  out   (c),d
                  out   (c),d
                  out   (c),d
                  out   (c),a
                  out   (c),d
                  out   (c),d
                  out   (c),d
                  out   (c),a
                  out   (c),d
                  out   (c),d
                  out   (c),a
                  out   (c),d
                  out   (c),a
                  out   (c),d
                  out   (c),a
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background

                  ; Row 6
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background

                  ; Row 7
                  out   (c),a
                  out   (c),e
                  out   (c),a
                  out   (c),e
                  out   (c),a
                  out   (c),e
                  out   (c),a
                  out   (c),e
                  out   (c),a
                  out   (c),e
                  out   (c),a
                  out   (c),a
                  out   (c),e
                  out   (c),a
                  out   (c),e
                  out   (c),a
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background

                  ; Row 8
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background

                  ; Row 9
                  out   (c),a
                  out   (c),e
                  out   (c),a
                  out   (c),e
                  out   (c),a
                  out   (c),e
                  out   (c),a
                  out   (c),e
                  out   (c),a
                  out   (c),e
                  out   (c),a
                  out   (c),a
                  out   (c),e
                  out   (c),a
                  out   (c),e
                  out   (c),a
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background

                  ; Row 10
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background

                  ; Row 11
                  out   (c),a
                  out   (c),b
                  out   (c),b
                  out   (c),b
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),a
                  out   (c),b
                  out   (c),b
                  nop
                  nop
                  out   (c),a
                  out   (c),a
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background
                  nop

                  ; Row 12
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  nop
                  nop
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background
                  nop

                  ; Row 13
                  out   (c),a
                  out   (c),b
                  out   (c),b
                  nop
                  out   (c),a
                  nop
                  nop
                  out   (c),b
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),a
                  out   (c),b
                  out   (c),b
                  nop
                  nop
                  out   (c),a
                  out   (c),a
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background
                  nop

                  ; Row 14
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background

                  ; Row 15
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background

                  ; Row 16
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background

                  ; Row 17
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background

                  ; Row 18
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background

                  ; Row 19
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),b
                  out   (c),b
                  out   (c),b
                  out   (c),a
                  out   (c),b
                  out   (c),b
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background

                  ; Row 20
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background

                  ; Row 21
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  nop
                  out   (c),b
                  out   (c),b
                  nop
                  out   (c),a
                  nop
                  nop
                  out   (c),b
                  nop
                  out   (c),a
                  nop
                  out   (c),b
                  out   (c),a
                  out   (c),b
                  out   (c),a
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background

                  ; Row 22
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background

                  ; Row 23
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background
                  out   (c),a  ; HIDDEN - Background

                  ; Play ST Music
                  push  bc
                  push  de
                  push  hl
                  call  50006
                  pop   hl
                  pop   de
                  ld    b,50
LoopX:            ld    a,(22528)   ; Sync loop for early/late timings
                  djnz  LoopX
                  pop   bc


                  xor   a
                  in    a,($FE)
                  and   $1F
                  cp    $1F
                  ld    a,0
                  jp    z,BorderLoop

ReturnToBASIC:    di
                  xor   a
                  ld    a,i
                  im    1
                  ei
                  ret

SetupIntHandler:  di
                  ; Put JR at $FFFF = JR to $FFF4
                  ld    a,$18
                  ld    ($FFFF),a

                  ; Put an EI, RET at $FFF4
                  ld    hl,$FFF4
                  ld    (hl),$FB
                  inc   hl
                  ld    (hl),$C9

                  ; Put interrupt vector table at $FE00
                  ld    hl,$FE00
                  ld    (hl),$FF
                  ld    de,$FE01
                  ld    bc,$0100
                  ldir
                  ld    a,$FE
                  ld    i,a
                  im    2
                  ei
                  ret

